<?php

namespace Fittest\Wordpress;

use Fittest\Fittest;
use Fittest\Experiment;
use Fittest\Variation\Page as Variation;
use Fittest\Goal\Uri as UriGoal;

class Menu
{
    public function __construct()
    {
        // add the hook for menu manipulation
        add_filter('nav_menu_link_attributes', array($this, 'init'), 10, 3);
    }
    
    public function init($atts, $item, $args)
    {
        // check the item if we need to experiment
        if ($item->object == 'fittest_experiment')
        {
            
            $goals = get_post_meta( $item->object_id, 'goals', true);
         
            // goal 0
            $goalid = 0;
            $goal = $goals[$goalid];
        
            // set up the experiment
            $id = $item->object_id;
            $experiment = Fittest::createExperiment($id);
            foreach($goal['pages'] as $pageid)
            {
                // add the page as a variation
                $variation = Variation::factory($pageid);
                Fittest::addVariation($variation, $experiment);
            }
            
            // get the chosen variantion
            $post = Fittest::chooseVariation($experiment)->get();
            
            // overwrite the item with all post data
            foreach($post as $k => $v)
            {
                $item->$k = $v;
            }
            
            // add goals
            $goal = new UriGoal($item->url);
            $experiment->addGoal($goal);
            $atts['href'] = $goal->getGoalUri();
        }
        
        return $atts;
    }
}