<?php

namespace Fittest\Algoritm;

use Fittest\Experiment;

class MultiArmedBandit extends Algoritm
{
    public function choose(Experiment $experiment)
    {
        if (rand(1,10) == 1)
        {
            // 10% of the time choose a random option
            $index = rand(0,$experiment->countVariations()-1);
            $choice = $experiment->getVariation($index);
        }
        else
        {
            $highscore = 0;
            
            // choose the option with the greatest expectation of reward
            foreach($experiment->getVariations() as $variation)
            {
                // calculate click through rate for this variation
                $awarded = $variation->getAwarded();
                $chosen = $variation->getChosen();
                $ctr = ($awarded / $chosen)*100;

                // hold the CTR against the highscore
                if ($ctr > $highscore)
                {
                    $highscore = $ctr;
                    $choice = $variation;
                }
            }
        }
        
        return $choice;
    }
}