<?php

namespace Fittest\Goal;

class Uri extends Goal
{
    private $uri;
    
    public function __construct($uri)
    {
        $this->uri = $uri;
    }
    
    protected function _reached()
    {
        return (boolean) ($this->getCurrentUri() == $this->getGoalUri());
    }
    
    public function getGoalUri()
    {
        $experiment = $this->getExperiment();
        
        $parts = parse_url($this->uri);
        $query = (strlen($parts['query']) > 0) ? '&' : '?';
        $query .= http_build_query(array(
            'fte' => $experiment->getId(),
            'ftv' => $experiment->chooseVariation()->getId()
        ));
        return $this->uri . $query;
    }
    
    public function getId()
    {
        return md5($this->getCurrentUri());
    }
    
    private function getCurrentUri() 
    {
        $pageURL = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') ? 'https://' : 'http://';
        $pageURL .= $_SERVER['SERVER_PORT'] != '80' ? $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"] : $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'];
        return $pageURL;
    }
}